/*
    ICRYPT+ kernel
	    -- DaP <profeta@freemail.c3.hu>
*/

/*
    $Log: icrypt+.c,v $
    Revision 1.1  2000/04/16 16:25:36  dap
    *** empty log message ***


    ---
    $Id: icrypt+.c,v 1.1 2000/04/16 16:25:36 dap Exp $
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>	/* time_t */
#include "icrypt+.h"
#include "rsaref/source/global.h"
#include "rsaref/source/rsaref.h"
#include "rsaref/source/rsa.h"

/* externs */
extern char DEBUGLEVEL;

/* must be global */
struct usert *usert;
R_RSA_PUBLIC_KEY PUBLIC_KEY = { 0 };
R_RSA_PRIVATE_KEY PRIVATE_KEY = { 0 };
R_RANDOM_STRUCT randomstruct;

/* prototypes */
void cp_initrandomstruct(R_RANDOM_STRUCT *randomstruct);


struct usert *user(int un)
{
    return(usert);
}


void cp_adduser()
{
    if (!(usert = malloc(sizeof(struct usert)))) {
	perror("malloc");
	exit(1);
    }
    usert->encrypt = NULL;
    usert->encryptreq = NULL;
}


void cp_deluser()
{
    free(usert);
}


/* the devil's seed */
void
cp_initrandomstruct(R_RANDOM_STRUCT *randomstruct)
{
    int i;


    R_RandomInit(randomstruct);
    for (;;) {
	R_GetRandomBytesNeeded(&i, randomstruct);
	if (!i)
	    break;
	i = rand();
	R_RandomUpdate(randomstruct, &i, 1);
    }
}


void
cp_HANDSHAKE_REQ(char *ircnick)
{
    R_RSA_PROTO_KEY protoKey;
    char buf1[400];
    char *pt;
    int i;


    if (!PUBLIC_KEY.bits || !PRIVATE_KEY.bits) {
	NOTICEUSER(ircnick, "Generating new RSA key...");

	protoKey.bits = RSA_KEYLEN;
	protoKey.useFermat4 = 1;
	if ((i = R_GeneratePEMKeys(&PUBLIC_KEY, &PRIVATE_KEY, &protoKey, &randomstruct))) {
	    printf("FATAL: R_GeneratePEMKeys: %d\n", i);
	    exit(1);
	}

	snprintf(buf1, sizeof(buf1),
		 "Public Key: %d bits (%d) -=- Private key: %d bits (%d)",
		 PUBLIC_KEY.bits, sizeof(PUBLIC_KEY), PRIVATE_KEY.bits,
		 sizeof(PRIVATE_KEY));
	NOTICEUSER(ircnick, buf1);
    }

    snprintf(buf1, sizeof(buf1), HANDSHAKE_REP "%s",
	     pt = hashstring((char *)&PUBLIC_KEY.modulus, MAX_RSA_MODULUS_LEN));
    SEND(ircnick, buf1);
    free(pt);

    snprintf(buf1, sizeof(buf1), "Public key sent to %s...", ircnick);
    NOTICEUSER(ircnick, buf1);

    // for (i = 0; i < MAX_RSA_MODULUS_LEN; i++) printf("%x", PUBLIC_KEY.exponent[i]);
}


void
cp_HANDSHAKE_REP(char *ircnick, char *irccontent)
{
    R_RSA_PUBLIC_KEY REMOTE_PUBLIC_KEY;
    char buf1[400], buf2[400], buf3[400];
    struct encryptreq *walker, *prev;
    char *pt;
    int i;


    sscanf(irccontent, HANDSHAKE_REP "%400s", buf1);

    snprintf(buf2, sizeof(buf2), "Got public key from %s...", ircnick);
    NOTICEUSER(ircnick, buf2);

    REMOTE_PUBLIC_KEY.bits = RSA_KEYLEN;
    memset(REMOTE_PUBLIC_KEY.exponent, 0, MAX_RSA_MODULUS_LEN);
    /* ugly hack! */
    REMOTE_PUBLIC_KEY.exponent[MAX_RSA_MODULUS_LEN - 1] = 0x01;
    REMOTE_PUBLIC_KEY.exponent[MAX_RSA_MODULUS_LEN - 1 - 2] = 0x01;
    memcpy(&REMOTE_PUBLIC_KEY.modulus, pt = (char *)unhashstring(buf1), MAX_RSA_MODULUS_LEN);
    free(pt);
    // for (i = 0; i < MAX_RSA_MODULUS_LEN; i++) printf("%x", REMOTE_PUBLIC_KEY.exponent[i]);


    /* session key generation */
    buf2[16] = '\0';
    for (i = 0; i < 16; i++)
	do
	    buf2[i] = (unsigned char) rand();
	while ((unsigned char) buf2[i] < 65 || (unsigned char) buf2[i] > 120);

    ucase(ircnick);
    prev = NULL;
    for (walker = user(usern)->encryptreq; walker; walker = walker->next) {
	if (walker->reqtime + TMOUT_REQ < time(NULL) || !strcmp(walker->to, ircnick)) {
	    snprintf(buf1, sizeof(buf1),
		     "%s exceed TMOUT_REQ or already has an obsoloted node...",
		     walker->to);
	    NOTICEUSER(ircnick, buf1);

	    if (prev)
		prev->next = walker->next;
	    else
		user(usern)->encryptreq = walker->next;
	    free(walker);
	}
	prev = walker;
    }

    if (!(walker = malloc(sizeof(struct encryptreq)))) {
	printf("FATAL: cannot get memory for encryptreq!");
	exit(1);
    }
    strcpy(walker->to, ircnick);
    strcpy(walker->pass, buf2);
    time(&(walker->reqtime));
    if (!user(usern)->encryptreq)
	walker->next = NULL;
    else
	walker->next = user(usern)->encryptreq;
    user(usern)->encryptreq = walker;


    if (RSAPublicEncrypt(buf2, &i, walker->pass, strlen(walker->pass) + 1,
			 &REMOTE_PUBLIC_KEY, &randomstruct)) {
	snprintf(buf2, sizeof(buf2),
		"RSA encrypt error on session key... maybe %s sent an illegal public key?",
		ircnick);
	NOTICEUSER(ircnick, buf2);
	return;
    }

    /* send encrypted session key */
    snprintf(buf3, sizeof(buf3), HANDSHAKE_KEY "%s", pt = hashstring(buf2, i));
    SEND(ircnick, buf3);
    free(pt);

    snprintf(buf3, sizeof(buf3), "Encrypted session key sent to %s...", ircnick);
    NOTICEUSER(ircnick, buf3);
}


void
cp_HANDSHAKE_KEY(char *ircnick, char *irccontent)
{
    char buf1[400], buf2[400], buf3[400];
    char *pt;
    int i;


    sscanf(irccontent, HANDSHAKE_KEY "%400s", buf1);

    snprintf(buf2, sizeof(buf2), "Got encrypted session key from %s...", ircnick);
    NOTICEUSER(ircnick, buf2);

    memcpy(buf2, pt = (char *)unhashstring(buf1), sizeof(buf2));
    free(pt);

    if (RSAPrivateDecrypt(buf1, &i, buf2, strlen(buf1) / 2, &PRIVATE_KEY)) {
	snprintf(buf1, sizeof(buf1),
		 "RSA decrypt error on session key... maybe %s sent an illegal encrypted session key?",
		 ircnick);
	NOTICEUSER(ircnick, buf1);
	return;
    }

    /* check for an obsoloted encryption entry */
    ucase(ircnick);
    i = 0;
    while ((pt = getstring(i, user(usern)->encrypt))) {
	if (!strncmp(pt, ircnick, strlen(ircnick))) {
	    snprintf(buf3, sizeof(buf3), "Deleted obsoloted session key for %s",
		     ircnick);
	    NOTICEUSER(ircnick, buf3);

	    user(usern)->encrypt = removestring(i, user(usern)->encrypt);
	    break;
	}
	i++;
    }
    /* enable encryption */
    // snprintf(buf3, sizeof(buf3), "%s:%s", ircnick, cryptit(buf1));
    snprintf(buf3, sizeof(buf3), "%s:%s", ircnick, buf1);
    user(usern)->encrypt = addstring(buf3, user(usern)->encrypt);

    /* send confirm (encrypted) */
    pt = BLOW_stringencrypt(HANDSHAKE_ACK, buf1);
    snprintf(buf3, sizeof(buf3), "%s%s", HANDSHAKE_ACK, pt);
    free(pt);
    SEND(ircnick, buf3);

    /* info */
    snprintf(buf3, sizeof(buf3), "You're guarded by blowfish448 (slave) (%s)",
	    buf1);
    NOTICEUSER(ircnick, buf3);
}


void
cp_HANDSHAKE_ACK(char *ircnick, char *irccontent)
{
    char buf1[400], buf2[400], buf3[400];
    struct encryptreq *walker, *prev;
    char *pt;
    int i;


    ucase(ircnick);
    prev = NULL;
    for (walker = user(usern)->encryptreq; walker; walker = walker->next) {
	if (!strcmp(walker->to, ircnick)) {
	    if (prev)
		prev->next = walker->next;
	    else
		user(usern)->encryptreq = walker->next;
	    break;
	}
	prev = walker;
    }
    if (!walker) {
	snprintf(buf1, sizeof(buf1), "Illegal ACK reply (%s not on encryptreq)...",
		 ircnick);
	NOTICEUSER(ircnick, buf1);
	return;
    }

    snprintf(buf1, sizeof(buf1), "Got ACK(?) from %s...", ircnick);
    NOTICEUSER(ircnick, buf1);

    pt = BLOW_stringdecrypt(irccontent + strlen(HANDSHAKE_ACK), walker->pass);
    if (!strstr(pt, HANDSHAKE_ACK)) {
	snprintf(buf1, sizeof(buf1),
		 "Illegal ACK reply sent by %s (unable to decrypt) (%s)...",
		 ircnick, walker->pass);
	NOTICEUSER(ircnick, buf1);
	free(pt);
	free(walker);
	return;
    }
    free(pt);

    /* check for an obsoloted encryption entry */
    i = 0;
    while ((pt = getstring(i, user(usern)->encrypt))) {
	if (!strncmp(pt, ircnick, strlen(ircnick))) {
	    snprintf(buf3, sizeof(buf3), "Deleted obsoloted session key for %s",
		     ircnick);
	    NOTICEUSER(ircnick, buf3);

	    user(usern)->encrypt = removestring(i, user(usern)->encrypt);
	    break;
	}
	i++;
    }
    // snprintf(buf3, sizeof(buf3), "%s:%s", ircnick, cryptit(walker->pass));
    snprintf(buf3, sizeof(buf3), "%s:%s", ircnick, walker->pass);
    user(usern)->encrypt = addstring(buf3, user(usern)->encrypt);

    /* info */
    snprintf(buf2, sizeof(buf2), "You're guarded by blowfish448 (master) (%s)",
	    walker->pass);
    NOTICEUSER(ircnick, buf2);

    /* 'cause req => session */
    free(walker);
}


int
cp_chk_HANDSHAKE_MSG(char *ircnick, char *irccontent)
{
    int i = 0;


    cp_initrandomstruct(&randomstruct);

    /* got handshake request & send public RSA key */
    if (strstr(irccontent, HANDSHAKE_REQ)) {
	cp_HANDSHAKE_REQ(ircnick);
	i++;
    }

    /* got public RSA key & send session key -- it's the real REQ! */
    if (strstr(irccontent, HANDSHAKE_REP)) {
	cp_HANDSHAKE_REP(ircnick, irccontent);
	i++;
    }

    /* decrypt session key & enable encryption */
    if (strstr(irccontent, HANDSHAKE_KEY)) {
	cp_HANDSHAKE_KEY(ircnick, irccontent);
	i++;
    }

    /* got encrypted ACK (or not :) */
    if (strstr(irccontent, HANDSHAKE_ACK)) {
	cp_HANDSHAKE_ACK(ircnick, irccontent);
	i++;
    }

    R_RandomFinal(&randomstruct);

    return(i);
}


struct stringarray *cp_findkey(char *passreq)
{
    struct stringarray *lkm;


    for (lkm = user(usern)->encrypt; lkm; lkm = lkm->next) {
	if (!strncmp(lkm->entry, passreq, strlen(passreq)))
	    break;
    }
    return(lkm);
}


int cp_isencrypted(char *_passreq)
{
    struct stringarray *lkm;
    char passreq[256];


    strncpy(passreq, _passreq, sizeof(passreq));
    ucase(passreq);

    if ((lkm = cp_findkey(passreq)))
	return(1);
    else
	return(0);
}


void cp_chk_crypt(char *_mynick, char *_ircnick, char *_from, char *irccontent, int irccontent_len, char fromme)
{
    char buf[2048];
    char mynick[64];
    char ircnick[64];
    char from[64];
    struct stringarray *lkm;
    // char *passreq
    char *pass;
    char *pt;
    unsigned short sign = 0;
    unsigned int skip = 0;
    char flags[9];
    int i;


    if (!strncmp(irccontent, NOENCRYPT, strlen(NOENCRYPT))) return;
    if (*irccontent == 0x01 && strncmp(irccontent, ACTION, strlen(ACTION))) return;

    strncpy(mynick, _mynick, sizeof(mynick));
    strncpy(ircnick, _ircnick, sizeof(ircnick));
    strncpy(from, _from, sizeof(from));
    ucase(mynick);
    ucase(ircnick);
    ucase(from);
/*
	ucase(ircto);
	ucase(ircnick);
	if (*ircfrom && *ircto != '#')
	    passreq = ircnick;
	else
	    passreq = ircto;
*/
    if (!(lkm = cp_findkey(ircnick))) {
	if (!fromme && *ircnick != '#' &&
	    !strncmp(irccontent, BLOWFISHENCRYPT, strlen(BLOWFISHENCRYPT))) {
	    // ismeretlen kulccsal titkositott msg
	    snprintf(buf, sizeof(buf), HANDSHAKE_REQ);
	    SEND(ircnick, buf);
	}
	return;
    }

    /* we've key... */
    // pass = decryptit(lkm->entry + strlen(ircnick) + 1);
    pass = lkm->entry + strlen(ircnick) + 1;

    if (!fromme && !strncmp(irccontent, BLOWFISHENCRYPT, strlen(BLOWFISHENCRYPT))) {
	/* incomin', encrypted */
	pt = BLOW_stringdecrypt(irccontent + strlen(BLOWFISHENCRYPT), pass);

	for (i = 0; from[i]; i++)
	    sign += from[i];

	*flags = '\0';
	if (*ircnick == '#') {
	    /* from channel */
	    if (*pt == *SIGN) {
		/* signed message */
		strncpy(buf, pt + 1, 4);
		sscanf(buf, "%x", &i);

		if (sign != i)
		    strncpy(flags, BADSIGN, sizeof(flags));

		skip = 6;
		// pt += 6;
	    } else {
		/* no sign */
		strncpy(flags, NOSIGN, sizeof(flags));
	    }
	}

	if (DEBUGLEVEL > 1) {
	    snprintf(buf, sizeof(buf), "DECODED RAW IN: (%s)", pt);
	    NOTICEUSER(ircnick, buf);
	}

	if (*(pt + skip) == 1) {
	    /* action */
	    //snprintf(ircbuf, sizeof(ircbuf), ":%s %s %s :"ACTION" %s%s",
		//    ircfrom, irccommand, ircto, flags, pt + strlen(ACTION) + 1 + skip);
	    snprintf(irccontent, irccontent_len, ACTION" %s%s",
		    flags, pt + strlen(ACTION) + 1 + skip);
	} else {
	    /* normal message */
	    //snprintf(ircbuf, sizeof(ircbuf), ":%s %s %s :%s%s",
		//    ircfrom, irccommand, ircto, flags, pt + skip);
	    snprintf(irccontent, irccontent_len, "%s%s", flags, pt + skip);
	}
	free(pt);
	return;
    }

    if (!fromme) {
	/* incomin', unencrypted (on encrypted channel) */
	if (*irccontent == 1) {
	    /* action */
	    //snprintf(ircbuf, sizeof(ircbuf), ":%s %s %s :"ACTION" "NOENCRYPT"%s",
		//    ircfrom, irccommand, ircto, irccontent + strlen(ACTION) + 1);
	    strncpy(buf, irccontent, sizeof(buf));
	    snprintf(irccontent, irccontent_len, ACTION" "NOENCRYPT"%s",
		    buf + strlen(ACTION) + 1);
	} else {
	    /* normal */
	    //snprintf(ircbuf, sizeof(ircbuf), ":%s %s %s :"NOENCRYPT"%s",
		//    ircfrom, irccommand, ircto, irccontent);
	    strncpy(buf, irccontent, sizeof(buf));
	    snprintf(irccontent, irccontent_len, NOENCRYPT"%s", buf);
	}
	return;
    }

    if (fromme && strncmp(irccontent, NOENCRYPT, strlen(NOENCRYPT))) {
	/* outgoin', encrypt req */
	strncpy(buf, mynick, sizeof(buf));
	ucase(buf);

	for (i = 0; buf[i]; i++)
	    sign += buf[i];

	if (*ircnick == '#') {
	    /* to channel */
	    strncpy(buf, irccontent, sizeof(buf));
	    snprintf(irccontent, irccontent_len, SIGN"%s", sign, buf);
	}

	pt = BLOW_stringencrypt(irccontent, pass);
	snprintf(irccontent, irccontent_len, BLOWFISHENCRYPT"%s", pt);
	free(pt);
	return;
    }
}
