/*
    CRYPT+ string hash functions from psybnc
				-- DaP <profeta@freemail.c3.hu>
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


extern char *BLOW_stringencrypt(unsigned char *input, unsigned char *key);
extern char *BLOW_stringdecrypt(unsigned char *input, unsigned char *key);


unsigned char base[]="'`0123456789abcdefghijklmnopqrstuvxyzABCDEFGHIJKLMNOPQRSTUVWXYZ@$=&*-#";
int baselen = 67;
unsigned char xres[3];
int wrong = 0;


unsigned long *pmalloc(unsigned long size)
{
    unsigned long *rc;
    rc=(unsigned long *)malloc(size);
    memset(rc,0x0,size);
    return rc;
}


unsigned char *hashdot(unsigned int r)
{
    unsigned int cnt;
    unsigned int hh=0;
    unsigned int hl=0;
    cnt=r;
    for(;cnt>0;cnt--)
    {
	hl++;
	if (hl==baselen) {hl=0;hh++;}
    }
    xres[0]=base[hh];
    xres[1]=base[hl];
    xres[2]=0;
    return xres;
}


unsigned int unhashdot(unsigned char *hash)
{
    unsigned int lf=baselen;
    unsigned char *pt;
    unsigned int erg=0;
    unsigned long ln=0;
    wrong=0;
    while (ln<baselen && base[ln] != hash[0]) {
	ln++;
    }
    if (ln!=baselen) {
	erg=ln * lf;
    } else {
	wrong=1;
    }
    ln=0;
    while (ln<baselen && base[ln] != hash[1]) {
	ln++;
    }
    if (ln!=baselen) {
	erg=erg+ln;
    } else {
	wrong=1;
    }
    return erg;
}


char *hashstring(unsigned char *unhashed,unsigned size)
{
    unsigned usize;
    unsigned char *bstring;
    unsigned char *hash;
    int chr;
    unsigned char *hsh;
    hsh=unhashed;
    usize=size;
    usize++;
    bstring=(char *)pmalloc(usize*2+1);
    usize=size;
    while(usize>0)
    {
	chr=*hsh++;
	hash=hashdot(chr);
	strcat(bstring,hash);
	usize--;
    }
    return bstring;
}


char *unhashstring(unsigned char *hashed)
{
    unsigned size;
    char *pi;
    char *result;
    unsigned char *uhshd,*uhash;
    size=strlen(hashed) / 2;
    size+=2;    
    result=(char *)pmalloc(size+9);
    if(result==NULL) return NULL;
    uhash=result;
    uhshd=hashed;
    while(*uhshd)
    {
	pi=uhshd+1;
	if(*pi==0 || *uhshd==0) return result;
	*uhash++=unhashdot(uhshd);
	if(wrong==1) return result;
	uhshd+=2;
    }
    return result;
}
