/************************************************************************
 *   psybnc2.1, src/p_string.c
 *   Copyright (C) 1999 the most psychoid  and
 *                      the cool lam3rz IRC Group, IRCnet
 *			http://www.psychoid.lam3rz.de
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef lint
static char rcsid[] = "@(#)$Id: p_string.c,v 1.1 2000/04/16 16:25:36 dap Exp $";
#endif

#define P_STRING

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>	/* umask() */
#include "icrypt+.h"	/* struct's */
// #include <p_global.h>

char ctxt[50];
int cline;

#define pcontext { snprintf(ctxt,sizeof(ctxt),"%s",__FILE__); cline=__LINE__; }
#define pmalloc(n) malloc(n);

/* ucase */

int ucase (char *inc)
{
   char *po;
   for (po = inc;*po;po++) *po = toupper( *po );
   return 0x0;
}

/* right trimming (no spaces on the right side) */

char *rtrim(char *totrim)
{
    int smlen;
    char *pnt;
    pnt = totrim;
    smlen = strlen(totrim);
    if (smlen>4095) smlen = 4095;
    pnt=pnt+smlen;
    while (*pnt == ' ' || *pnt== 0x0) { *pnt=0x0; pnt--; }
    return totrim;
}

/* replaces given character with another character */

int replace(char *rps,char whatc, char toc)
{
   char *p1;    
   p1=strchr(rps,whatc);
   while (p1) {
      *p1=toc;
      p1++;
      p1=strchr(p1,whatc);
   }
}

char nbr[8192];

/* this routine filters breaks out of a ircstring */

char *nobreak(char *tobreak)
{
    int smlen;
    char *pnt;
    pnt=strchr(tobreak,'\r');
    if(pnt==NULL) pnt=strchr(tobreak,'\n');
    if (pnt != NULL) {
       smlen = pnt-tobreak;
       smlen++;
       if (smlen > 8191) {smlen=8191;}
       snprintf(nbr,smlen,"%s",tobreak);
       pnt = nbr;
    } else {
      pnt = tobreak;
    }
    return rtrim(pnt);
}

/* string add with memory mapping */

char *strmcat(char *first,char *second)
{
    char *n;
    pcontext;
    n=(char *)pmalloc(strlen(first)+strlen(second)+2);
    strcpy(n,first);
    strcat(n,second);
    pcontext;
    free(first);
    pcontext;
    return n;
}

/* stringarray - support 
 * added for saving the lists to memory */

struct stringarray *addstring(char *toadd, struct stringarray *ltm)
{
    struct stringarray *th;
    if (ltm==NULL) {
	ltm=(struct stringarray *) pmalloc(sizeof(struct stringarray));
	ltm->next=NULL;
	ltm->entry=NULL;
    }
    th=ltm;
    first=th;
    while (th->entry!=NULL) 
    {
	if (th->next==NULL) {
	    th->next=(struct stringarray *) pmalloc(sizeof(struct stringarray));
	    th->next->entry=NULL;
	    th->next->next=NULL;
	}
        th=th->next;
    }
    th->entry=(char *) pmalloc(strlen(toadd)+3);
    snprintf(th->entry,strlen(toadd)+1,"%s%c",toadd,0);
    return first; /* returning parent node */
}

char vbuf[650];

char *getstring(int entry, struct stringarray *ltm)
{
    int cnt;
    struct stringarray *th;
    char *tt;
    th=ltm;
    cnt=0;
    while (1)
    {
	if (th==NULL) return NULL;
	if (cnt==entry) {
	    if (th->entry==NULL) return NULL;
	    memset(vbuf,0x0,sizeof(vbuf));
	    snprintf(vbuf,sizeof(vbuf),"%s",th->entry);
	    tt=vbuf;
	    return tt;
	}
	th=th->next;
	cnt++;	
    }    
}

struct stringarray *removestring(int entry, struct stringarray *ltm)
{
    int cnt;
    struct stringarray *th;
    struct stringarray *lastth;
    th=ltm;
    lastth=NULL;
    cnt=0;
    while (th!=NULL)
    {
	if (cnt==entry) {
	    if (th==ltm) {
		first=th->next;
		if (th->entry!=NULL) free(th->entry);
		th->entry=NULL;
		free(th);
		return first;
	    } else {
		lastth->next=th->next;
		if(th->entry!=NULL) free(th->entry);
		th->entry=NULL;
		free(th);
		first=ltm;
		return first;
	    }
	} 
	lastth=th;
	th=th->next;
	cnt++;	
    }
    first=ltm;
    return first;
}
/* read all lines from a file to a stringarray */

struct stringarray *loadlist(char *afile,struct stringarray *th)
{
    FILE *handle;
    char buf[4096];
    char buf2[4096];
    if ((handle=fopen(afile,"r"))==NULL) return 0x0;
    first=th;
    while(fgets(buf,sizeof(buf),handle)) {
	snprintf(buf2,sizeof(buf2),"%s",nobreak(buf));
	first=addstring(buf2,first);
    }
    fclose(handle);
    return first;
}


/* write a line, maybe also dupes to a filelist */

struct stringarray *writelist(char *host, char *param, char *afile,struct stringarray *th)
{
    FILE *handle;
    char buf[8192];


    umask(066);		/* DaP */
    handle = fopen(afile,"a");
    snprintf(buf,sizeof(buf),"%s:%s\n",host,param);
    fprintf(handle,buf);
    fclose(handle);
    snprintf(buf,sizeof(buf),"%s:%s",host,param);
    first=addstring(buf,th);
    return first;
}

/* erase a matching entry from a file */

struct stringarray *eraselist(int entry, char *afile,struct stringarray *th)
{
    FILE *infile;
    FILE *tmp;
    struct stringarray *ith;
    char fbuf[40];
    char buf[8192];
    int counter;
    counter=0;
    first=removestring(entry,th);
    snprintf(fbuf,sizeof(fbuf),"%s.tmp",afile);
    if ((infile = fopen(afile,"r")) == NULL) {
	return first;
    }
    if ((tmp = fopen(fbuf,"w")) == NULL) {
	fclose(infile);
	return first;
    }
    while (fgets(buf,sizeof(buf),infile))
    {
	if (counter != entry) {
	   fprintf(tmp,buf);
	}
	counter++;
    }
    fclose(infile);
    fclose(tmp);
    rename(fbuf,afile);
    return first;
}
